% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/F018.run.umap.R
\name{run.umap}
\alias{run.umap}
\title{Run UMAP on PCA Data (Computes a manifold approximation and projection)}
\usage{
run.umap(x = NULL, dims = 1:10, method = "naive")
}
\arguments{
\item{x}{An object of class iCellR.}

\item{dims}{PC dimentions to be used for UMAP analysis.}

\item{method}{Character, implementation. Available methods are 'naive' (an implementation written in pure R) and 'umap-learn' (requires python package 'umap-learn'). Choose from "naive" and "umap-learn", default = "naive".}
}
\value{
An object of class iCellR.
}
\description{
This function takes an object of class iCellR and runs UMAP on PCA data.
}
\examples{
demo.obj <- run.umap(demo.obj, dims = 1:10)
head(demo.obj@umap.data)

}
